<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qbs-module.qdoc -->
  <title>qbs QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
<li class="level2"><a href="#installation-properties">Installation Properties</a></li>
<li class="level2"><a href="#multiplexing-properties">Multiplexing Properties</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">qbs QML Type</h1>
<span class="subtitle"></span>
<!-- $$$qbs-brief -->
<p>Comprises general properties. <a href="#details">More...</a></p>
<!-- @@@qbs -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsModules .</td></tr><tr><td class="memItemLeft rightAlign topAlign"> Since:</td><td class="memItemRight bottomAlign"> Qbs 1.0</td></tr></table></div><ul>
<li><a href="qml-qbsmodules-qbs-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#architecture-prop">architecture</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#architectures-prop">architectures</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#buildVariant-prop">buildVariant</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#buildVariants-prop">buildVariants</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#configurationName-prop">configurationName</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#debugInformation-prop">debugInformation</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#enableDebugCode-prop">enableDebugCode</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#hostOS-prop">hostOS</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#hostOSBuildVersion-prop">hostOSBuildVersion</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#hostOSVersion-prop">hostOSVersion</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#hostOSVersionMajor-prop">hostOSVersionMajor</a></b></b> : int</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#hostOSVersionMinor-prop">hostOSVersionMinor</a></b></b> : int</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#hostOSVersionParts-prop">hostOSVersionParts</a></b></b> : list</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#hostOSVersionPatch-prop">hostOSVersionPatch</a></b></b> : int</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#hostPlatform-prop">hostPlatform</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#install-prop">install</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#installDir-prop">installDir</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#installPrefix-prop">installPrefix</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#installRoot-prop">installRoot</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#installSourceBase-prop">installSourceBase</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#nullDevice-prop">nullDevice</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#optimization-prop">optimization</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#pathListSeparator-prop">pathListSeparator</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#profiles-prop">profiles</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#shellPath-prop">shellPath</a></b></b> : path</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#sysroot-prop">sysroot</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#targetOS-prop">targetOS</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#targetPlatform-prop">targetPlatform</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#toolchain-prop">toolchain</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#toolchainType-prop">toolchainType</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#version-prop">version</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#versionMajor-prop">versionMajor</a></b></b> : int</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#versionMinor-prop">versionMinor</a></b></b> : int</li>
<li class="fn"><b><b><a href="qml-qbsmodules-qbs.html#versionPatch-prop">versionPatch</a></b></b> : int</li>
</ul>
<!-- $$$qbs-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>The <code>qbs</code> module is implicitly loaded in every product. It contains properties of the current build environment, independent of the used programming languages and toolchains.</p>
<a name="installation-properties"></a>
<h3 id="installation-properties">Installation Properties</h3>
<p>Typically, you use <a href="qml-qbslanguageitems-group.html">Group</a> items to specify the target directories for installing files. To install a group of files, set the <a href="qml-qbsmodules-qbs.html#install-prop">qbs.install</a> property of the Group to <code>true</code>. The value of <a href="qml-qbsmodules-qbs.html#installDir-prop">qbs.installDir</a> specifies the path to the directory where the files will be installed. You can specify a base directory for all installation directories as the value of <a href="qml-qbsmodules-qbs.html#installPrefix-prop">qbs.installPrefix</a>.</p>
<p>For example, the following properties specify where a set of QML files and an application executable are installed on Windows and Linux:</p>
<pre class="cpp plain">

  Application {
      name: &quot;myapp&quot;
      Group {
          name: &quot;Runtime resources&quot;
          files: &quot;*.qml&quot;
          qbs.install: true
          qbs.installDir: condition: qbs.targetOS.contains(&quot;unix&quot;)
              ? &quot;share/myapp&quot; : &quot;resources&quot;
      }
      Group {
          name: &quot;The App itself&quot;
          fileTagsFilter: &quot;application&quot;
          qbs.install: true
          qbs.installDir: &quot;bin&quot;
      }
      qbs.installPrefix: condition: qbs.targetOS.contains(&quot;unix&quot;)
          ? &quot;usr/local&quot; : &quot;MyApp&quot;
  }

</pre>
<p>On Windows, the QML files will ultimately get installed in <code>MyApp\resources</code> and the application executable in <code>MyApp\bin</code>, for instance under <code>C:\Program Files</code>. On Linux, the QML files will be installed in <code>/usr/local/share/myapp</code> and the executable in <code>/usr/local/bin</code>.</p>
<p>By default, <a href="qml-qbsmodules-qbs.html#installRoot-prop">qbs.installRoot</a> creates the <code>install-root</code> directory in the build directory for packaging the binaries before installation. It is a temporary directory that is usually not available when the application is run, and it should therefore not be set in the project files. You can override the default value from the command line, as described in <a href="installing-files.html">Installing Files</a>.</p>
<a name="multiplexing-properties"></a>
<h3 id="multiplexing-properties">Multiplexing Properties</h3>
<p>The following properties are specific to <a href="multiplexing.html">product multiplexing</a>:</p>
<ul>
<li><a href="qml-qbsmodules-qbs.html#architectures-prop">architectures</a></li>
<li><a href="qml-qbsmodules-qbs.html#buildVariants-prop">buildVariants</a></li>
<li><a href="qml-qbsmodules-qbs.html#profiles-prop">profiles</a></li>
</ul>
<!-- @@@qbs -->
<h2>Property Documentation</h2>
<!-- $$$architecture -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="architecture-prop">
<td class="tblQmlPropNode"><p>
<span class="name">architecture</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The target platform's processor architecture.</p>
<p><code>undefined</code> indicates that the target platform is architecture-independent (for example the CLR or JVM).</p>
<p>This property is typically set in a profile.</p>
<p>Commonly used values are: <code>&quot;x86&quot;</code>, <code>&quot;x86_64&quot;</code>, and <code>&quot;arm&quot;</code>.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@architecture -->
<br/>
<!-- $$$architectures -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="architectures-prop">
<td class="tblQmlPropNode"><p>
<span class="name">architectures</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The architectures the product will be built for.</p>
<p>Default: Undefined</p>
<p>This property was introduced in Qbs 1.9.</p>
</div></div><!-- @@@architectures -->
<br/>
<!-- $$$buildVariant -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="buildVariant-prop">
<td class="tblQmlPropNode"><p>
<span class="name">buildVariant</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The name of the build variant for the current build.</p>
<p>Possible values are <code>&quot;debug&quot;</code> and <code>&quot;release&quot;</code>. A debug build usually contains additional debug symbols that are needed for debugging the application but that can be left out from the release version. Debug builds are used for testing and release builds for creating the final installation file.</p>
<p>Default: <code>&quot;release&quot;</code> if <a href="qml-qbsmodules-qbs.html#configurationName-prop">qbs.configurationName</a> is <code>&quot;release&quot;</code>. Otherwise <code>&quot;debug&quot;</code></p>
</div></div><!-- @@@buildVariant -->
<br/>
<!-- $$$buildVariants -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="buildVariants-prop">
<td class="tblQmlPropNode"><p>
<span class="name">buildVariants</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The build variants the product will be built for.</p>
<p>Default: Undefined</p>
<p>This property was introduced in Qbs 1.9.</p>
</div></div><!-- @@@buildVariants -->
<br/>
<!-- $$$configurationName -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="configurationName-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">configurationName</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The name of the current build configuration.</p>
<p>The build configuration is set via the command line parameter <code>config</code>. For more information, see <a href="cli-build.html">build</a>.</p>
<p>Default: <code>&quot;default&quot;</code></p>
<p>This property was introduced in Qbs 1.6.</p>
</div></div><!-- @@@configurationName -->
<br/>
<!-- $$$debugInformation -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="debugInformation-prop">
<td class="tblQmlPropNode"><p>
<span class="name">debugInformation</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Whether to generate debug information.</p>
<p>Default: <code>true</code> for debug builds, <code>false</code> otherwise.</p>
</div></div><!-- @@@debugInformation -->
<br/>
<!-- $$$enableDebugCode -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="enableDebugCode-prop">
<td class="tblQmlPropNode"><p>
<span class="name">enableDebugCode</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Whether to enable debug functionality in the product. Not to be confused with generation of debug symbols or the code optimization level.</p>
<p>The property changes the following things when enabled:</p>
<ul>
<li>Passes a flag to the Windows linker to link against a debug Windows CRT (common runtime) library (for example /MTd instead of /MT)</li>
</ul>
<p>The property changes the following things when disabled:</p>
<ul>
<li>Passes the <code>NDEBUG</code> define to the compiler</li>
</ul>
<p>Typically, this property is enabled for debug builds and disabled for release builds.</p>
<p>Default: <code>true</code> for debug builds, <code>false</code> otherwise.</p>
</div></div><!-- @@@enableDebugCode -->
<br/>
<!-- $$$hostOS -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="hostOS-prop">
<td class="tblQmlPropNode"><p>
<span class="name">hostOS</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property is set by Qbs internally and specifies the OS Qbs is running on.</p>
<p>The possible values for this property are the values of <a href="qml-qbsmodules-qbs.html#targetOS-prop">targetOS</a>, even though some of them may not be supported.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@hostOS -->
<br/>
<!-- $$$hostOSBuildVersion -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="hostOSBuildVersion-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">hostOSBuildVersion</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The host operating system's build version. Currently, only defined for Windows and Apple platforms.</p>
<p>On Windows, this is the 4 or 5 digit Windows build number and is equivalent to <a href="qml-qbsmodules-qbs.html#versionPatch-prop">versionPatch</a>. On Apple platforms, this is a standard build number in the Apple versioning scheme. For example, <code>&quot;13C64&quot;</code>.</p>
<p>Default: Undefined</p>
<p>This property was introduced in Qbs 1.2.</p>
</div></div><!-- @@@hostOSBuildVersion -->
<br/>
<!-- $$$hostOSVersion -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="hostOSVersion-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">hostOSVersion</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The host operating system version. Currently, only defined for Windows and Apple platforms.</p>
<p>Consists of two or three numbers separated by dots. For example, <code>&quot;10.9&quot;</code> or <code>&quot;6.3&#x2e;9600&quot;</code>.</p>
<p>Default: Undefined</p>
<p>This property was introduced in Qbs 1.2.</p>
</div></div><!-- @@@hostOSVersion -->
<br/>
<!-- $$$hostOSVersionMajor -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="hostOSVersionMajor-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">hostOSVersionMajor</span> : <span class="type">int</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The host operating system major version.</p>
<p>Default: <code>hostOSVersionParts[0]</code></p>
<p>This property was introduced in Qbs 1.2.</p>
</div></div><!-- @@@hostOSVersionMajor -->
<br/>
<!-- $$$hostOSVersionMinor -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="hostOSVersionMinor-prop">
<td class="tblQmlPropNode"><p>
<span class="name">hostOSVersionMinor</span> : <span class="type">int</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The host operating system minor version.</p>
<p>Default: <code>hostOSVersionParts[1]</code></p>
<p>This property was introduced in Qbs 1.2.</p>
</div></div><!-- @@@hostOSVersionMinor -->
<br/>
<!-- $$$hostOSVersionParts -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="hostOSVersionParts-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">hostOSVersionParts</span> : <span class="type">list</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The host operating system version as a list.</p>
<p>For example, Windows 8.1 (version 6.3&#x2e;9600) would correspond to a value of <code>[6, 3, 9600]</code>.</p>
<p>Default: <code>[]</code></p>
<p>This property was introduced in Qbs 1.2.</p>
</div></div><!-- @@@hostOSVersionParts -->
<br/>
<!-- $$$hostOSVersionPatch -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="hostOSVersionPatch-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">hostOSVersionPatch</span> : <span class="type">int</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The host operating system patch level.</p>
<p>Default: <code>hostOSVersionParts[2]</code></p>
<p>This property was introduced in Qbs 1.2.</p>
</div></div><!-- @@@hostOSVersionPatch -->
<br/>
<!-- $$$hostPlatform -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="hostPlatform-prop">
<td class="tblQmlPropNode"><p>
<span class="name">hostPlatform</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Do not use this property.</p>
<p>Default: Determined automatically.</p>
<p>This property was introduced in Qbs 1.11.</p>
</div></div><!-- @@@hostPlatform -->
<br/>
<!-- $$$install -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="install-prop">
<td class="tblQmlPropNode"><p>
<span class="name">install</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Whether to install a certain set of files.</p>
<p>This property is typically set in a <a href="qml-qbslanguageitems-group.html">Group</a> item to mark a number of files as installable.</p>
<p><b>Note: </b>Artifacts for which this property is enabled automatically receive the file tag <code>&quot;installable&quot;</code>. This is useful for writing packaging-related rules.</p><p>Default: <code>false</code></p>
</div></div><!-- @@@install -->
<br/>
<!-- $$$installDir -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="installDir-prop">
<td class="tblQmlPropNode"><p>
<span class="name">installDir</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The installation directory for the files of a <a href="qml-qbslanguageitems-product.html">product</a> or a <a href="qml-qbslanguageitems-group.html">Group</a>.</p>
<p>The value of this property is a path that is relative to <a href="qml-qbsmodules-qbs.html#installPrefix-prop">installPrefix</a>.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@installDir -->
<br/>
<!-- $$$installPrefix -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="installPrefix-prop">
<td class="tblQmlPropNode"><p>
<span class="name">installPrefix</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The global installation prefix. It is implicitly prepended to all values of <a href="qml-qbsmodules-qbs.html#installDir-prop">installDir</a>.</p>
<p>The value of this property itself is relative to the <a href="qml-qbsmodules-qbs.html#installRoot-prop">installRoot</a> in the context of installation.</p>
<p>Default: <code>&quot;/usr/local&quot;</code> on Unix, <code>&quot;&quot;</code> otherwise</p>
<p>This property was introduced in Qbs 1.1.</p>
</div></div><!-- @@@installPrefix -->
<br/>
<!-- $$$installRoot -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="installRoot-prop">
<td class="tblQmlPropNode"><p>
<span class="name">installRoot</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The global installation root. It is implicitly prepended to all values of <a href="qml-qbsmodules-qbs.html#installPrefix-prop">installPrefix</a> in the context of installation.</p>
<p><b>Note: </b>This property is fundamentally different from <a href="qml-qbsmodules-qbs.html#installDir-prop">installDir</a> and <a href="qml-qbsmodules-qbs.html#installPrefix-prop">installPrefix</a> in that it must not be visible to the code being built. In fact, the install root is often just a temporary location used to package the binaries, which should therefore not assume they will be in that location at run-time. For the same reason, this property is usually not set from within project files.</p><p>Default: <code>&lt;build dir&gt;/install-root</code></p>
<p>This property was introduced in Qbs 1.4.</p>
</div></div><!-- @@@installRoot -->
<br/>
<!-- $$$installSourceBase -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="installSourceBase-prop">
<td class="tblQmlPropNode"><p>
<span class="name">installSourceBase</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The base directory of the local files that are going to be installed. The source base directory is omitted from the target directory path specified in <a href="qml-qbsmodules-qbs.html#installDir-prop">installDir</a>.</p>
<p>Default: The directory of the current file to be installed, relative to the product's source directory.</p>
<p>This property was introduced in Qbs 1.4.</p>
</div></div><!-- @@@installSourceBase -->
<br/>
<!-- $$$nullDevice -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="nullDevice-prop">
<td class="tblQmlPropNode"><p>
<span class="name">nullDevice</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The platform-specific file path corresponding to the null device.</p>
<p>Default: <code>&quot;NUL&quot;</code> on Windows, <code>&quot;/dev/null&quot;</code> on Unix.</p>
<p>This property was introduced in Qbs 1.4&#x2e;2.</p>
</div></div><!-- @@@nullDevice -->
<br/>
<!-- $$$optimization -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="optimization-prop">
<td class="tblQmlPropNode"><p>
<span class="name">optimization</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The general type of optimization that should be performed by all toolchains.</p>
<p>Allowed values are:</p>
<ul>
<li><code>&quot;fast&quot;</code></li>
<li><code>&quot;none&quot;</code></li>
<li><code>&quot;small&quot;</code></li>
</ul>
<p>Default: <code>&quot;none&quot;</code> for debug builds, <code>&quot;fast&quot;</code> for release builds.</p>
</div></div><!-- @@@optimization -->
<br/>
<!-- $$$pathListSeparator -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="pathListSeparator-prop">
<td class="tblQmlPropNode"><p>
<span class="name">pathListSeparator</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The platform-specific separator for a path list that is used in environment variables or other contexts.</p>
<p>Default: <code>&quot;;&quot;</code> on Windows, <code>&quot;:&quot;</code> on Unix.</p>
</div></div><!-- @@@pathListSeparator -->
<br/>
<!-- $$$profiles -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="profiles-prop">
<td class="tblQmlPropNode"><p>
<span class="name">profiles</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The profiles for which the product should be built.</p>
<p>For each profile listed here, one instance of the product will be built according to the properties set in the respective profile.</p>
<p>Default: <a href="qml-qbslanguageitems-project.html#profile-prop">[project.profile]</a></p>
<p>This property was introduced in Qbs 1.9.</p>
</div></div><!-- @@@profiles -->
<br/>
<!-- $$$shellPath -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="shellPath-prop">
<td class="tblQmlPropNode"><p>
<span class="name">shellPath</span> : <span class="type">path</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The platform-specific file path corresponding to the command line interpreter.</p>
<p>On Windows, this is the path to <code>cmd.exe</code>, which is held in the <code>COMSPEC</code> environment variable (typically, <code>C:/Windows/System32/cmd.exe</code>), On Unix-like platforms, this is <code>/bin/sh</code>.</p>
<p>Default: <code>&quot;%COMSPEC%&quot;</code> on Windows, <code>&quot;/bin/sh&quot;</code> on Unix</p>
<p>This property was introduced in Qbs 1.5.</p>
</div></div><!-- @@@shellPath -->
<br/>
<!-- $$$sysroot -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="sysroot-prop">
<td class="tblQmlPropNode"><p>
<span class="name">sysroot</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The <code>sysroot</code> of the target platform.</p>
<p>This property is typically set in a profile for cross-compiling.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@sysroot -->
<br/>
<!-- $$$targetOS -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="targetOS-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">targetOS</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Contains the list of string values describing the OS and OS family that is used to build a project.</p>
<p>This property is calculated based on the <a href="qml-qbsmodules-qbs.html#targetPlatform-prop">targetPlatform</a> property and is typically used to test for a particular OS or OS family in conditionals:</p>
<pre class="cpp">

  Group {
      <span class="comment">// Includes all Unix-like platforms, such as: Linux, BSD, Apple platforms and others.</span>
      condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;unix&quot;</span>)
      files: <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span>
  }
  Group {
      <span class="comment">// Includes all Apple platforms, such as macOS, iOS, and iOS Simulator.</span>
      condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;darwin&quot;</span>)
      files: <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span>
  }
  Group {
      <span class="comment">// Includes only macOS</span>
      condition: qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;macos&quot;</span>)
      files: <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span>
  }

</pre>
<p>Avoid using <a href="qml-qbsmodules-qbs.html#targetPlatform-prop">targetPlatform</a> for this purpose. For example, instead of:</p>
<pre class="cpp">

  qbs<span class="operator">.</span>targetPlatform <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;macos&quot;</span> <span class="operator">|</span><span class="operator">|</span> qbs<span class="operator">.</span>targetPlatform <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;ios&quot;</span> <span class="operator">|</span><span class="operator">|</span> qbs<span class="operator">.</span>targetPlatform <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;tvos&quot;</span> <span class="operator">|</span><span class="operator">|</span> qbs<span class="operator">.</span>targetPlatform <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;watchos&quot;</span>

</pre>
<p>use</p>
<pre class="cpp">

  qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;darwin&quot;</span>)

</pre>
<p>However, in some cases using <a href="qml-qbsmodules-qbs.html#targetPlatform-prop">targetPlatform</a> would be acceptable, such as when the resulting condition would be simpler while still being correct:</p>
<pre class="cpp">

  qbs<span class="operator">.</span>targetPlatform <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;linux&quot;</span>

</pre>
<p>versus</p>
<pre class="cpp">

  qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;linux&quot;</span>) <span class="operator">&amp;</span><span class="operator">&amp;</span> <span class="operator">!</span>qbs<span class="operator">.</span>targetOS<span class="operator">.</span>contains(<span class="string">&quot;android&quot;</span>)

</pre>
<p>For the complete list of possible values, see <a href="qml-qbsmodules-qbs.html#relation-between-targetplatform-and-targetos">Relation between targetPlatform and targetOS</a>.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@targetOS -->
<br/>
<!-- $$$targetPlatform -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="targetPlatform-prop">
<td class="tblQmlPropNode"><p>
<span class="name">targetPlatform</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The OS you want to build the project for.</p>
<p>This property is typically set in a profile or for a particular product where the target OS is always known (such as an Apple Watch app written in native code).</p>
<p>For example, a profile used for building for the iOS Simulator platform will have this property set to the <code>ios-simulator</code> value:</p>
<pre class="cpp">

  profiles<span class="operator">.</span>xcode<span class="operator">-</span>iphonesimulator<span class="operator">.</span>qbs<span class="operator">.</span>targetPlatform: <span class="string">&quot;ios-simulator&quot;</span>

</pre>
<p>You should generally treat this property as <i>write-only</i> and avoid using it to test for the current target OS. Instead, use the <a href="qml-qbsmodules-qbs.html#targetOS-prop">targetOS</a> property for conditionals.</p>
<a name="relation-between-targetplatform-and-targetos"></a>
<h5 id="relation-between-targetplatform-and-targetos">Relation between targetPlatform and targetOS</h5>
<p>This table describes the possible values and matching between the <code>targetPlatform</code> and the <a href="qml-qbsmodules-qbs.html#targetOS-prop">targetOS</a> properties:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Target Platform</th><th >Target OS</th></tr></thead>
<tr valign="top" class="odd"><td ><code>&quot;aix&quot;</code></td><td ><code>[&quot;aix&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;android&quot;</code></td><td ><code>[&quot;android&quot;, &quot;linux&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;freebsd&quot;</code></td><td ><code>[&quot;freebsd&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;haiku&quot;</code></td><td ><code>[&quot;haiku&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;hpux&quot;</code></td><td ><code>[&quot;hpux&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;hurd&quot;</code></td><td ><code>[&quot;hurd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;integrity&quot;</code></td><td ><code>[&quot;integrity&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;ios&quot;</code></td><td ><code>[&quot;ios&quot;, &quot;darwin&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;ios-simulator&quot;</code></td><td ><code>[&quot;ios-simulator&quot;, &quot;ios&quot;, &quot;darwin&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;linux&quot;</code></td><td ><code>[&quot;linux&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;lynx&quot;</code></td><td ><code>[&quot;lynx&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;macos&quot;</code></td><td ><code>[&quot;macos&quot;, &quot;darwin&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;netbsd&quot;</code></td><td ><code>[&quot;netbsd&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;openbsd&quot;</code></td><td ><code>[&quot;openbsd&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;qnx&quot;</code></td><td ><code>[&quot;qnx&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;solaris&quot;</code></td><td ><code>[&quot;solaris&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;tvos&quot;</code></td><td ><code>[&quot;tvos&quot;, &quot;darwin&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;tvos-simulator&quot;</code></td><td ><code>[&quot;tvos-simulator&quot;, &quot;tvos&quot;, &quot;darwin&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;vxworks&quot;</code></td><td ><code>[&quot;vxworks&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;watchos&quot;</code></td><td ><code>[&quot;watchos&quot;, &quot;darwin&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="odd"><td ><code>&quot;watchos-simulator&quot;</code></td><td ><code>[&quot;watchos-simulator&quot;, &quot;watchos&quot;, &quot;darwin&quot;, &quot;bsd&quot;, &quot;unix&quot;]</code></td></tr>
<tr valign="top" class="even"><td ><code>&quot;windows&quot;</code></td><td ><code>[&quot;windows&quot;]</code></td></tr>
</table></div>
<p>Default: Undefined</p>
<p>This property was introduced in Qt 1.11.</p>
<p><b>See also </b><a href="platforms.html">Target Platforms</a>.</p>
</div></div><!-- @@@targetPlatform -->
<br/>
<!-- $$$toolchain -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="toolchain-prop">
<td class="tblQmlPropNode"><p>
<span class="name">toolchain</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The attributes of the toolchain that is going to be used for this build.</p>
<p>Typical values include <code>&quot;llvm&quot;</code>, in addition to the possible values of <a href="qml-qbsmodules-qbs.html#toolchainType-prop">toolchainType</a>.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@toolchain -->
<br/>
<!-- $$$toolchainType -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="toolchainType-prop">
<td class="tblQmlPropNode"><p>
<span class="name">toolchainType</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The toolchain that is going to be used for this build.</p>
<p>You should generally treat this property as <i>write-only</i> and avoid using it to test for the current toolchain. Instead, use the <a href="qml-qbsmodules-qbs.html#toolchain-prop">toolchain</a> property for conditionals.</p>
<p>For example, instead of:</p>
<pre class="cpp">

  (qbs<span class="operator">.</span>toolchainType <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;xcode&quot;</span> <span class="operator">|</span><span class="operator">|</span> qbs<span class="operator">.</span>toolchainType <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;clang&quot;</span> <span class="operator">|</span><span class="operator">|</span> qbs<span class="operator">.</span>toolchainType <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;gcc&quot;</span>)

</pre>
<p>use:</p>
<pre class="cpp">

  qbs<span class="operator">.</span>toolchain<span class="operator">.</span>contains(<span class="string">&quot;gcc&quot;</span>)

</pre>
<p>However, there are some cases when using <code>toolchainType</code> would be acceptable, such as when the resulting condition would be simpler while still being correct:</p>
<pre class="cpp">

  (qbs<span class="operator">.</span>toolchainType <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;gcc&quot;</span>)

</pre>
<p>versus:</p>
<pre class="cpp">

  (qbs<span class="operator">.</span>toolchain<span class="operator">.</span>contains(<span class="string">&quot;gcc&quot;</span>) <span class="operator">&amp;</span><span class="operator">&amp;</span> <span class="operator">!</span>qbs<span class="operator">.</span>toolchain<span class="operator">.</span>contains(<span class="string">&quot;clang&quot;</span>))

</pre>
<p>Typical values include: <code>&quot;gcc&quot;</code>, <code>&quot;clang&quot;</code>, <code>&quot;mingw&quot;</code>, <code>&quot;msvc&quot;</code>, and <code>&quot;xcode&quot;</code>.</p>
<p>Default: Determined automatically.</p>
<p>This property was introduced in Qbs 1.11.</p>
</div></div><!-- @@@toolchainType -->
<br/>
<!-- $$$version -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="version-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">version</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The version number of Qbs as a string. For example, <code>&quot;1.4&#x2e;1&quot;</code>.</p>
<p>This property was introduced in Qbs 1.4&#x2e;1.</p>
</div></div><!-- @@@version -->
<br/>
<!-- $$$versionMajor -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="versionMajor-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">versionMajor</span> : <span class="type">int</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The major version number of Qbs.</p>
<p>This property was introduced in Qbs 1.4&#x2e;1.</p>
</div></div><!-- @@@versionMajor -->
<br/>
<!-- $$$versionMinor -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="versionMinor-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">versionMinor</span> : <span class="type">int</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The minor version number of Qbs.</p>
<p>This property was introduced in Qbs 1.4&#x2e;1.</p>
</div></div><!-- @@@versionMinor -->
<br/>
<!-- $$$versionPatch -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="versionPatch-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">versionPatch</span> : <span class="type">int</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The patch version number of Qbs.</p>
<p>This property was introduced in Qbs 1.4&#x2e;1.</p>
</div></div><!-- @@@versionPatch -->
<br/>
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
